/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
import mx.collections.ArrayCollection;

[Bindable]
private var _items_for_combobox:ArrayCollection; // for combobox

[Bindable]
private var _items:Array = [];                   // [{$CustomeComboBoxItemDto},....]
private var _selected_id:int;

/**
 * set items.
 * 
 * @param items
 * @param selected id
 */
public function setItems(items:Array, selected_id:int):void {
  this._items = items;
  this._items_for_combobox = new ArrayCollection(this._items);
  
  if (selected_id > -1)
    this.setSelected_id(selected_id);
}

/**
 * get selected item id.
 * 
 */
public function getSelectedItemId():int {
  return (
     this.selectedIndex == -1
  || this.dataProvider == null
  || this.dataProvider.length == 0 
    ? 0
    : this.dataProvider[this.selectedIndex].id
  );
}

/**
 * selected id.
 * 
 * @param selected id
 */
private function setSelected_id(selected_id:int):void {
  this._selected_id = selected_id;
  
  for (var i:int = 0; i < this._items.length; i++) {
    if (this._selected_id == this._items[i].id) {
      this.selectedIndex = i;
      break;
    }
  }
}
