/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
import flash.net.SharedObject;

import mx.managers.PopUpManager;

import org.seasar.tugboat.gtd.auth.Authorize;
import org.seasar.tugboat.gtd.commons.Constants;

/**
 * initialize.
 */
public function init():void {
  var shared_object:SharedObject
    = SharedObject.getLocal("tugboat-gtd-url");
  
  var url:String =
    shared_object.data.url == null
    ? Constants.DEFAULT_URL
    : shared_object.data.url;
  
  if (shared_object.data.url == null) {
    shared_object.data.url = url;
    shared_object.flush();
  }
  label_url.text = url;
}

/**
 * show conn url popup.
 */
private function _show_conn_url_popup():void {
  var connection_url:component.ServerURLPopUpWindow =
    component.ServerURLPopUpWindow( 
      PopUpManager.createPopUp(this, component.ServerURLPopUpWindow, true));
  
  connection_url.set_label_url(label_url);
  connection_url.x = (this.width -  connection_url.width)  / 2;
  connection_url.y = (this.height - connection_url.height) / 2;
}

/**
 * after authorized.
 * 
 * @param is_successful
 * @param message
 */
private function _after_authorized(is_successful:Boolean, message:String):void {
  if (! is_successful) {
    this.message.text = message;
    return;
  }
  this.message.text = "";
  this.dispatchEvent(new Event("move_to_main",false,false));
}

/**
 * authorize.
 */
private function _authorize():void {
  var auth:Authorize = 
    Authorize.getComponent(
      this.label_url.text, Constants.HTTP_ACCEPT_JSON, _after_authorized);
  
  auth.login(login_id.text, password.text);
}