/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
import mx.managers.CursorManager;
import org.seasar.tugboat.gtd.commons.Constants;

private var _selected_mode:Number = Constants.MODE_BLOCK;
private var _current_page:Number = 1;
private var _total_page:Number = 1;

[Bindable]
public var selected_value:String;

/**
 * block on click.
 */
private function _block_onclick():void {
  if (this._selected_mode == Constants.MODE_BLOCK) return;
  
  this._selected_mode = Constants.MODE_BLOCK;
  this.block_mode_button.setStyle("backgroundImage","images/default/icon/layout_blocks_inactive.gif");
  this.list_mode_button.setStyle("backgroundImage","images/default/icon/layout_list.gif");
  
  this.dispatchEvent(new Event("block_onclick"));  
}

/**
 * list on click.
 */
private function _list_onclick():void {
  if (this._selected_mode == Constants.MODE_LIST) return;
  
  this._selected_mode = Constants.MODE_LIST;
  this.block_mode_button.setStyle("backgroundImage","images/default/icon/layout_blocks.gif");
  this.list_mode_button.setStyle("backgroundImage","images/default/icon/layout_list_inactive.gif");
  
  this.dispatchEvent(new Event("list_onclick"));
}

/**
 * previous page button on click.
 */
private function _prev_onclick():void {
  if (this._current_page == 1) return;
  this._current_page--;
  this.dispatchEvent(new Event("prev_onclick"));
}

/**
 * next page button onclick.
 */
private function _next_onclick():void {
  if (this._current_page == this._total_page) return;
  this._current_page++;
  this.dispatchEvent(new Event("next_onclick")); 
}