/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.commons {
  import org.seasar.tugboat.gtd.dto.BrowseClassificationDto;
  
  /**
   * constants for components.
   * 
   */
  public class Constants{
    // default url
    public static var DEFAULT_URL:String = "http://127.0.0.1:8080";

    // http.accept
    public static var HTTP_ACCEPT:String      = "Accept";
    public static var HTTP_ACCEPT_JSON:String = "application/json";
    public static var HTTP_ACCEPT_ATOM:String = "application/atom+xml";
    
    public static var HTTP_WSSE:String            = "X-WSSE";
    public static var HTTP_METHOD_OVERRIDE:String = "X-HTTP-Method-Override";
    
    // uri
    public static var URI_AUTH:String             = "/rest/authorize";;
    public static var URI_TASKS:String            = "/rest/tasks";
    public static var URI_ACTIVITIES:String       = "/rest/activities";
    public static var URI_ACTIVITY_MEMBERS:String = "/rest/activityMembers";
    
    // http method
    public static var HTTP_GET:String    = "GET";
    public static var HTTP_POST:String   = "POST";
    public static var HTTP_UPDATE:String = "PUT";
    public static var HTTP_DELETE:String = "DELETE";
    
    // lines per page
    public static var LINES_PER_PAGE:Number = 50;
    
    // roles
    public static var USER_ROLES:Array = [
      {id:1, name:"Owner", icon:"images/default/icon/contact_admin.gif" },
      {id:2, name:"User",  icon:"images/default/icon/contact_user.gif"  }
      //{id:3, name:"Guest", icon:"" }
    ];
    public static function get_user_role(id:int):Object {
      var user_role:Object = null;
      for (var i:int; i < USER_ROLES.length; i++) {
        if (id == USER_ROLES[i].id) {
          user_role = USER_ROLES[i];
        }
      }
      return user_role;
    }
    
  	// Folder [selected, hover, default]
  	public static var COLOR_FOLDER_DRAG_ENTER:String= "#FFFFCC";
    public static var COLOR_FOLDER_SELECTED:String  = "#E4DEF4";
    public static var COLOR_FOLDER_HOVER:String     = "#FFFFCC";
    public static var COLOR_FOLDER_DEFAULT:String   = "#EEEEFF";

    // task.card.background.images
    public static var TASK_CARD_BACKGROUND:Array = [
      {class_id:1,  status_id:1, is_myself:true,  image:"images/default/card/png/today_todo.png"},
      {class_id:1,  status_id:2, is_myself:true,  image:"images/default/card/png/today_doing.png"},
      {class_id:1,  status_id:3, is_myself:true,  image:"images/default/card/png/today_done.png"},
      {class_id:2,  status_id:1, is_myself:true,  image:"images/default/card/png/week.png"},
      {class_id:3,  status_id:1, is_myself:true,  image:"images/default/card/png/month.png"},
      {class_id:4,  status_id:1, is_myself:true,  image:"images/default/card/png/hold_todo.png"},
      {class_id:4,  status_id:3, is_myself:true,  image:"images/default/card/png/hold_done.png"},
      {class_id:5,  status_id:1, is_myself:true,  image:"images/default/card/png/someday.png"},
      {class_id:9,  status_id:1, is_myself:true,  image:"images/default/card/png/inbox.png"},
      {class_id:21, status_id:3, is_myself:true,  image:"images/default/card/png/archive.png"},
      {class_id:99, status_id:1, is_myself:true,  image:"images/default/card/png/trash.png"},
      
      {class_id:1,  status_id:1, is_myself:false, image:"images/default/card/png/today_todo_another.png"},
      {class_id:1,  status_id:2, is_myself:false, image:"images/default/card/png/today_doing_another.png"},
      {class_id:1,  status_id:3, is_myself:false, image:"images/default/card/png/today_done_another.png"},
      {class_id:2,  status_id:1, is_myself:false, image:"images/default/card/png/week_another.png"},
      {class_id:3,  status_id:1, is_myself:false, image:"images/default/card/png/month_another.png"},
      {class_id:4,  status_id:1, is_myself:false, image:"images/default/card/png/hold_todo_another.png"},
      {class_id:4,  status_id:3, is_myself:false, image:"images/default/card/png/hold_done_another.png"},
      {class_id:5,  status_id:1, is_myself:false, image:"images/default/card/png/someday_another.png"},
      {class_id:9,  status_id:1, is_myself:false, image:"images/default/card/png/inbox_another.png"},
      {class_id:21, status_id:3, is_myself:false, image:"images/default/card/png/archive_another.png"},
      {class_id:99, status_id:1, is_myself:false, image:"images/default/card/png/trash_another.png"}
    ];
    
    /**
     * get task card image. 
     * @param class_id
     * @param status_id
     * @param is_myself
     * @return
     */
    public static function get_task_card_image(
      class_id:Number, status_id:Number, is_myself:Boolean):Object {
        
      var result:Object = null;
      for (var i:Number = 0; i < TASK_CARD_BACKGROUND.length; i++) {
        if (class_id == TASK_CARD_BACKGROUND[i].class_id
         && status_id == TASK_CARD_BACKGROUND[i].status_id
         && is_myself == TASK_CARD_BACKGROUND[i].is_myself) {

           result = TASK_CARD_BACKGROUND[i];
           break;
         }
      }
      return result;
    }

    // task.gtd-folder
    public static var FOLDER_TASKS:String       = "folder_all";
    public static var FOLDER_TODAY:String       = "folder_today";
    public static var FOLDER_WEEK:String        = "folder_week";
    public static var FOLDER_MONTH:String       = "folder_month";
    public static var FOLDER_HOLD:String        = "folder_hold";
    public static var FOLDER_SOMEDAY:String     = "folder_someday";
    public static var FOLDER_INBOX:String       = "folder_inbox";
    public static var FOLDER_TODAY_TODO:String  = "folder_today_todo";
    public static var FOLDER_TODAY_DOING:String = "folder_today_doing";
    public static var FOLDER_TODAY_DONE:String  = "folder_today_done";
    public static var FOLDER_ARCHIVE:String     = "folder_archives";
    public static var FOLDER_TRASH:String       = "folder_trash";
    
    public static var GTD_FOLDERS:Array = [
      {id:9,  classId:9,  status_id:1,  label:FOLDER_INBOX,      value:"In-box",   is_selectable:true, icon:"images/default/folder/gif/inbox-16.gif"            },
      {id:11, classId:1,  status_id:1,  label:FOLDER_TODAY_TODO, value:"To Do",    is_selectable:true, icon:"images/default/folder/png/folder-red-todo-16.png"  },
      {id:12, classId:1,  status_id:2,  label:FOLDER_TODAY_DOING,value:"Doing",    is_selectable:true, icon:"images/default/folder/png/folder-red-doing-16.png" },
      {id:13, classId:1,  status_id:3,  label:FOLDER_TODAY_DONE, value:"Done",     is_selectable:true, icon:"images/default/folder/png/folder-red-done-16.png"  },
      {id:2,  classId:2,  status_id:1,  label:FOLDER_WEEK,       value:"Week",     is_selectable:true, icon:"images/default/folder/png/folder-orange-16.png"    },
      {id:3,  classId:3,  status_id:1,  label:FOLDER_MONTH,      value:"Month",    is_selectable:true, icon:"images/default/folder/png/folder-yellow-16.png"    },
      {id:4,  classId:4,  status_id:1,  label:FOLDER_HOLD,       value:"Hold",     is_selectable:true, icon:"images/default/folder/png/folder-green-16.png"     },
      {id:43, classId:4,  status_id:3,  label:FOLDER_HOLD,       value:"Hold Done",is_selectable:true, icon:"images/default/folder/png/folder-green-done-16.png"},
      {id:5,  classId:5,  status_id:1,  label:FOLDER_SOMEDAY,    value:"Someday",  is_selectable:true, icon:"images/default/folder/png/folder-blue-16.png"      },
      {id:99, classId:99, status_id:1,  label:FOLDER_TRASH,      value:"Trash",    is_selectable:true, icon:"images/default/folder/gif/trash-16.gif"            },

      {id:0,  classId:0,  status_id:-1, label:FOLDER_TASKS,      value:"", is_selectable:false, icon:"", order:-1},
      {id:1,  classId:1,  status_id:-1, label:FOLDER_TODAY,      value:"", is_selectable:false, icon:"", order:-1},
      {id:21, classId:21, status_id:3,  label:FOLDER_ARCHIVE,    value:"", is_selectable:false, icon:"", order:-1}
    ];

    /**
     * get folder.
     * 
     * @param label 
     */
    public static function get_folder(label:String):Object {
      var result:Object = null;
      for (var i:Number = 0; i < GTD_FOLDERS.length; i++) {
        if (label == GTD_FOLDERS[i].label) {
          result = GTD_FOLDERS[i];
          break;
        }
      }
      return result;
    }
    
    /**
     * 
     * 
     */
    public static function get_folder_by_status_and_class(status:int, classification:int):Object {
      var result:Object = null;
      for (var i:Number = 0; i < GTD_FOLDERS.length; i++) {
        if (status == GTD_FOLDERS[i].status_id && classification == GTD_FOLDERS[i].classId) {
          result = GTD_FOLDERS[i];
          break;
        }
      }
      return result;
    }

    // gtd classes.    
    public static var GTD_CLASSES:Array = [
      {id:0,  value:"All",      icon:"images/default/icon/space.gif"},
      {id:1,  value:"Today",    icon:"images/default/folder/png/folder-red-16.png"},
      {id:2,  value:"Week",     icon:"images/default/folder/png/folder-orange-16.png"},
      {id:3,  value:"Month",    icon:"images/default/folder/png/folder-yellow-16.png"},
      {id:4,  value:"Hold",     icon:"images/default/folder/png/folder-green-16.png"},
      {id:5,  value:"Someday",  icon:"images/default/folder/png/folder-blue-16.png"},
      {id:9,  value:"Inbox",    icon:"images/default/folder/gif/inbox-16.gif"},
      {id:21, value:"Archives", icon:"images/default/folder/png/folder-gray-16.png"},
      {id:99, value:"Trash",    icon:"images/default/folder/gif/trash-16.gif"}
    ];

    /**
     * get classification.
     *  
     * @param id
     * @return
     */
    public static function get_classification(id:Number):Object {
      var result:Object = null;
      for (var i:Number = 0; i < GTD_CLASSES.length; i++) {
        var _class:Object = GTD_CLASSES[i];
        if (id == _class.id) {
          result = _class;
          break;
        }
      }
      return result;
    }
    
    // gtd folder rules.
    public static var CLASS_FOLDER_RULES:Array = [
      { id:0,
        classes:[
          {id:0, selected:true,  enable:true},
          {id:1, selected:false, enable:true},
          {id:2, selected:false, enable:true},
          {id:3, selected:false, enable:true},
          {id:4, selected:false, enable:true},
          {id:5, selected:false, enable:true}
        ]
      },
      {id:1,  classes:[{id:1, selected:true, enable:false}]},
      {id:2,  classes:[{id:2, selected:true, enable:false}]},
      {id:3,  classes:[{id:3, selected:true, enable:false}]},
      {id:4,  classes:[{id:4, selected:true, enable:false}]},
      {id:5,  classes:[{id:5, selected:true, enable:false}]},
      {id:9,  classes:[{id:9, selected:true, enable:false}]},
      {id:21, classes:[{id:21,selected:true, enable:false}]},
      {id:99, classes:[{id:99,selected:true, enable:false}]}
    ];
    
    /**
     * get class folder rules.
     * 
     * @param id 
     * @return
     */
    public static function get_class_folder_rules(id:Number):Object {
      var result:Object = null;
      for (var i:Number = 0; i < CLASS_FOLDER_RULES.length; i++) {
        var rule:Object = CLASS_FOLDER_RULES[i];
        if (id == rule.id) {
          result = rule;
          break;
        }
      }
      return result;
    }
    
    /**
     * get classes for browser. 
     * 
     * @param id
     */
    public static function get_classes_for_browser(id:Number):Array {
      var rule:Object = get_class_folder_rules(id);
      var array:Array = [];
      for (var i:Number = 0; i < rule.classes.length; i++) {
        var _class:Object = get_classification(rule.classes[i].id);
        array.push(
          new BrowseClassificationDto(
            _class.id, _class.value, _class.icon, rule.classes[i].selected, rule.classes[i].enable)
        );
        //array.push(getClassification(_class.id));
      }
      return array;
    }
    
    // activity colors.
    public static var ACTIVITIY_COLORS:Array = [
      { id:1,  color_hex:0xff0000, label:'Red',         icon:'images/default/palette/pl_bg_ff0000.gif'},
      { id:2,  color_hex:0xff8000, label:'Orange',      icon:'images/default/palette/pl_bg_ff8000.gif'},
      { id:3,  color_hex:0xffff00, label:'Yellow',      icon:'images/default/palette/pl_bg_ffff00.gif'},
      { id:4,  color_hex:0x80ff00, label:'Lime',        icon:'images/default/palette/pl_bg_80ff00.gif'},
      { id:5,  color_hex:0x00ff00, label:'Green',       icon:'images/default/palette/pl_bg_00ff00.gif'},
      { id:6,  color_hex:0x00ffff, label:'Aqua',        icon:'images/default/palette/pl_bg_00ffff.gif'},
      { id:7,  color_hex:0x0080ff, label:'Sky',         icon:'images/default/palette/pl_bg_0080ff.gif'},
      { id:8,  color_hex:0x0000ff, label:'Blue',        icon:'images/default/palette/pl_bg_0000ff.gif'},
      { id:9,  color_hex:0x8000ff, label:'Purple',      icon:'images/default/palette/pl_bg_8000ff.gif'},
      { id:10, color_hex:0xff00ff, label:'Pink',        icon:'images/default/palette/pl_bg_ff00ff.gif'},
      { id:11, color_hex:0x660000, label:'Dark red',    icon:'images/default/palette/pl_bg_660000.gif'},
      { id:12, color_hex:0x663300, label:'Dark orange', icon:'images/default/palette/pl_bg_663300.gif'},
      { id:13, color_hex:0x666600, label:'Dark yellow', icon:'images/default/palette/pl_bg_666600.gif'},
      { id:14, color_hex:0x336600, label:'Dark lime',   icon:'images/default/palette/pl_bg_336600.gif'},
      { id:15, color_hex:0x006600, label:'Dark green',  icon:'images/default/palette/pl_bg_006600.gif'},
      { id:16, color_hex:0x006666, label:'Dark aqua',   icon:'images/default/palette/pl_bg_006666.gif'},
      { id:17, color_hex:0x000066, label:'Dark blue',   icon:'images/default/palette/pl_bg_000066.gif'},
      { id:18, color_hex:0x660066, label:'Dark pink',   icon:'images/default/palette/pl_bg_660066.gif'} 
    ];
    
    /**
     * get activity color. 
     * 
     * @param color_hex
     */
    public static function get_activity_color(color_hex:Number):Object {
      var result:Object = null;
      for (var i:Number = 0; i < ACTIVITIY_COLORS.length; i++) {
        if (color_hex == ACTIVITIY_COLORS[i].color_hex) {
          result = ACTIVITIY_COLORS[i];
          break;
        }
      }
      return result;
    }
   
   // view mode.
   public static var MODE_BLOCK:Number = 1;
   public static var MODE_LIST:Number = 2;
    
  }
}