/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.dto {
  import org.seasar.tugboat.gtd.commons.Constants;
  
  public class ActivityDto {
    [Bindable]
    public var id:int;
    
    [Bindable]
    public var name:String;
    
    [Bindable]
    public var color:Number;
    
    [Bindable]
    public var icon:String;
    
    [Bindable]
    public var description:String;
    
    /**
     * @param id 
     * @param name
     * @param color_value
     */
    public function ActivityDto(id:int, name:String, color:Number, description:String) {
      this.id = id;
      this.name = name;
      this.color = color;
      this.description = description;
      
      if (color > 0)
        this.icon = Constants.get_activity_color(color).icon;
    }
  }
}