/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.dto{
  public class TaskQueryConditionDto{
    public function TaskQueryConditionDto() {
    }

    public var id:Number;
    public var folder_id:Number;

    public var classes:Array;
    public var activities:Array;
    public var people:Array;
    
    /**
     * classes to string. 
     * @return classes.
     */
    public function classes_to_string():String {
      var result:String = "";
      if (this.classes == null || this.classes.length == 0) {
        result = "0";
      } else if (this.folder_id == 0 && this.classes[0] == 0) {
        result = "1,2,3,4,5";  
      } else {
        result = this._array_to_string(this.classes);
      }
      return result;
    }
    /**
     * activities to string.
     * @return activities.
     */
    public function activities_to_string():String {
      if (this.activities == null || this.activities.length == 0) {
        return "0";
      }
      return this._array_to_string(this.activities);
    }
    /**
     * people to string.
     * @reurn people.
     */
    public function people_to_string():String {
      if (this.people == null || this.people.length == 0) {
        return "0";
      }
      return this._array_to_string(this.people);
    }
    
    /**
     * array to string.
     * @param array
     * @return string.
     * 
     */
    private function _array_to_string(array:Array):String {
      var result:String = "";
      for each (var c:Number in array) {
        result += c + ",";
      }
      trace(result);
      return result.substring(0, result.length-1);
    }
    
    /**
     * to string.
     * @return - string
     */
    public function toString():String {
      var result:Object =
        { id:this.id, folder_id:this.folder_id,
          classes:this.classes, activities:this.activities, people:this.people};
      return result.toString();
    }
  }
}